<template>
  <base-container>
    <div :class="$style.productPageWrapper">
      <base-loading v-if="requestProductDetailPending"></base-loading>
      <error-component v-if="!requestProductDetailPending && hasErrorGetter">
        The product you are looking for doesn't exist, unfortunately :( you will
        redirect to home page...
      </error-component>
      <product-item
        v-if="!requestProductDetailPending && selectedProductDeatilGetter"
        :date="selectedProductDeatilGetter.foundeDate"
        :title="selectedProductDeatilGetter.title"
        :categories="selectedProductDeatilGetter.categories"
        :description="selectedProductDeatilGetter.description"
        :image="selectedProductDeatilGetter.image"
        :id="selectedProductDeatilGetter.id"
      ></product-item>
    </div>
  </base-container>
</template>

<script>
// vuex
import { createNamespacedHelpers } from "vuex";
import ActionTypes from "@/store/modules/product/action-types";
// components
import BaseContainer from "@/components/base/BaseGrid/container.vue";
import BaseLoading from "@/components/base/BaseLoading";

// other components
import ProductItem from "@/components/product/ProductItem/index.vue";
import ErrorComponent from "@/components/base/BaseError/index.vue";

// utils
const { mapState, mapActions, mapGetters } = createNamespacedHelpers(
  "products"
);

export default {
  name: "Home",
  components: {
    BaseLoading,
    BaseContainer,
    ProductItem,
    ErrorComponent
  },
  computed: {
    ...mapState(["requestProductDetailPending"]),
    ...mapGetters(["selectedProductDeatilGetter", "hasErrorGetter"])
  },
  watch: {
    hasErrorGetter: function(newValue) {
      // just to show watch
      if (newValue) {
        setTimeout(() => {
          this.$router.push("/");
        }, 3000);
      }
    }
  },
  methods: {
    ...mapActions([ActionTypes.GET_PRODUCT_BY_ID])
  },

  mounted() {
    const { productId } = this.$route.params;
    this[ActionTypes.GET_PRODUCT_BY_ID]({ productId });
  },
  beforeRouteEnter(to, from, next) {
    // we can get data here too and if he/she wasn't authenticated or product doesnt exist redirect him/her to error page.
    next();
  }
};
</script>
<style module lang="scss">
.productPageWrapper {
  min-height: calc(100vh - 70px);
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--center;
}
</style>
